/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface SharePluginframeworkConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.63.0/docs/resources/share_pluginframework#comment SharePluginframework#comment}
    */
    readonly comment?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.63.0/docs/resources/share_pluginframework#name SharePluginframework#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.63.0/docs/resources/share_pluginframework#owner SharePluginframework#owner}
    */
    readonly owner?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.63.0/docs/resources/share_pluginframework#storage_location SharePluginframework#storage_location}
    */
    readonly storageLocation?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.63.0/docs/resources/share_pluginframework#storage_root SharePluginframework#storage_root}
    */
    readonly storageRoot?: string;
    /**
    * object block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.63.0/docs/resources/share_pluginframework#object SharePluginframework#object}
    */
    readonly object?: SharePluginframeworkObject[] | cdktf.IResolvable;
}
export interface SharePluginframeworkObjectPartitionValue {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.63.0/docs/resources/share_pluginframework#name SharePluginframework#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.63.0/docs/resources/share_pluginframework#op SharePluginframework#op}
    */
    readonly op: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.63.0/docs/resources/share_pluginframework#recipient_property_key SharePluginframework#recipient_property_key}
    */
    readonly recipientPropertyKey?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.63.0/docs/resources/share_pluginframework#value SharePluginframework#value}
    */
    readonly value?: string;
}
export declare function sharePluginframeworkObjectPartitionValueToTerraform(struct?: SharePluginframeworkObjectPartitionValue | cdktf.IResolvable): any;
export declare function sharePluginframeworkObjectPartitionValueToHclTerraform(struct?: SharePluginframeworkObjectPartitionValue | cdktf.IResolvable): any;
export declare class SharePluginframeworkObjectPartitionValueOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): SharePluginframeworkObjectPartitionValue | cdktf.IResolvable | undefined;
    set internalValue(value: SharePluginframeworkObjectPartitionValue | cdktf.IResolvable | undefined);
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _op?;
    get op(): string;
    set op(value: string);
    get opInput(): string | undefined;
    private _recipientPropertyKey?;
    get recipientPropertyKey(): string;
    set recipientPropertyKey(value: string);
    resetRecipientPropertyKey(): void;
    get recipientPropertyKeyInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    resetValue(): void;
    get valueInput(): string | undefined;
}
export declare class SharePluginframeworkObjectPartitionValueList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: SharePluginframeworkObjectPartitionValue[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): SharePluginframeworkObjectPartitionValueOutputReference;
}
export interface SharePluginframeworkObjectPartition {
    /**
    * value block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.63.0/docs/resources/share_pluginframework#value SharePluginframework#value}
    */
    readonly value?: SharePluginframeworkObjectPartitionValue[] | cdktf.IResolvable;
}
export declare function sharePluginframeworkObjectPartitionToTerraform(struct?: SharePluginframeworkObjectPartition | cdktf.IResolvable): any;
export declare function sharePluginframeworkObjectPartitionToHclTerraform(struct?: SharePluginframeworkObjectPartition | cdktf.IResolvable): any;
export declare class SharePluginframeworkObjectPartitionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): SharePluginframeworkObjectPartition | cdktf.IResolvable | undefined;
    set internalValue(value: SharePluginframeworkObjectPartition | cdktf.IResolvable | undefined);
    private _value;
    get value(): SharePluginframeworkObjectPartitionValueList;
    putValue(value: SharePluginframeworkObjectPartitionValue[] | cdktf.IResolvable): void;
    resetValue(): void;
    get valueInput(): cdktf.IResolvable | SharePluginframeworkObjectPartitionValue[] | undefined;
}
export declare class SharePluginframeworkObjectPartitionList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: SharePluginframeworkObjectPartition[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): SharePluginframeworkObjectPartitionOutputReference;
}
export interface SharePluginframeworkObject {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.63.0/docs/resources/share_pluginframework#cdf_enabled SharePluginframework#cdf_enabled}
    */
    readonly cdfEnabled?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.63.0/docs/resources/share_pluginframework#comment SharePluginframework#comment}
    */
    readonly comment?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.63.0/docs/resources/share_pluginframework#content SharePluginframework#content}
    */
    readonly content?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.63.0/docs/resources/share_pluginframework#data_object_type SharePluginframework#data_object_type}
    */
    readonly dataObjectType: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.63.0/docs/resources/share_pluginframework#history_data_sharing_status SharePluginframework#history_data_sharing_status}
    */
    readonly historyDataSharingStatus?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.63.0/docs/resources/share_pluginframework#name SharePluginframework#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.63.0/docs/resources/share_pluginframework#shared_as SharePluginframework#shared_as}
    */
    readonly sharedAs?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.63.0/docs/resources/share_pluginframework#start_version SharePluginframework#start_version}
    */
    readonly startVersion?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.63.0/docs/resources/share_pluginframework#string_shared_as SharePluginframework#string_shared_as}
    */
    readonly stringSharedAs?: string;
    /**
    * partition block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.63.0/docs/resources/share_pluginframework#partition SharePluginframework#partition}
    */
    readonly partition?: SharePluginframeworkObjectPartition[] | cdktf.IResolvable;
}
export declare function sharePluginframeworkObjectToTerraform(struct?: SharePluginframeworkObject | cdktf.IResolvable): any;
export declare function sharePluginframeworkObjectToHclTerraform(struct?: SharePluginframeworkObject | cdktf.IResolvable): any;
export declare class SharePluginframeworkObjectOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): SharePluginframeworkObject | cdktf.IResolvable | undefined;
    set internalValue(value: SharePluginframeworkObject | cdktf.IResolvable | undefined);
    get addedAt(): number;
    get addedBy(): string;
    private _cdfEnabled?;
    get cdfEnabled(): boolean | cdktf.IResolvable;
    set cdfEnabled(value: boolean | cdktf.IResolvable);
    resetCdfEnabled(): void;
    get cdfEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _comment?;
    get comment(): string;
    set comment(value: string);
    resetComment(): void;
    get commentInput(): string | undefined;
    private _content?;
    get content(): string;
    set content(value: string);
    resetContent(): void;
    get contentInput(): string | undefined;
    private _dataObjectType?;
    get dataObjectType(): string;
    set dataObjectType(value: string);
    get dataObjectTypeInput(): string | undefined;
    get effectiveCdfEnabled(): cdktf.IResolvable;
    get effectiveHistoryDataSharingStatus(): string;
    get effectiveSharedAs(): string;
    get effectiveStartVersion(): number;
    private _historyDataSharingStatus?;
    get historyDataSharingStatus(): string;
    set historyDataSharingStatus(value: string);
    resetHistoryDataSharingStatus(): void;
    get historyDataSharingStatusInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _sharedAs?;
    get sharedAs(): string;
    set sharedAs(value: string);
    resetSharedAs(): void;
    get sharedAsInput(): string | undefined;
    private _startVersion?;
    get startVersion(): number;
    set startVersion(value: number);
    resetStartVersion(): void;
    get startVersionInput(): number | undefined;
    get status(): string;
    private _stringSharedAs?;
    get stringSharedAs(): string;
    set stringSharedAs(value: string);
    resetStringSharedAs(): void;
    get stringSharedAsInput(): string | undefined;
    private _partition;
    get partition(): SharePluginframeworkObjectPartitionList;
    putPartition(value: SharePluginframeworkObjectPartition[] | cdktf.IResolvable): void;
    resetPartition(): void;
    get partitionInput(): cdktf.IResolvable | SharePluginframeworkObjectPartition[] | undefined;
}
export declare class SharePluginframeworkObjectList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: SharePluginframeworkObject[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): SharePluginframeworkObjectOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/databricks/databricks/1.63.0/docs/resources/share_pluginframework databricks_share_pluginframework}
*/
export declare class SharePluginframework extends cdktf.TerraformResource {
    static readonly tfResourceType = "databricks_share_pluginframework";
    /**
    * Generates CDKTF code for importing a SharePluginframework resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the SharePluginframework to import
    * @param importFromId The id of the existing SharePluginframework that should be imported. Refer to the {@link https://registry.terraform.io/providers/databricks/databricks/1.63.0/docs/resources/share_pluginframework#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the SharePluginframework to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/databricks/databricks/1.63.0/docs/resources/share_pluginframework databricks_share_pluginframework} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options SharePluginframeworkConfig
    */
    constructor(scope: Construct, id: string, config: SharePluginframeworkConfig);
    private _comment?;
    get comment(): string;
    set comment(value: string);
    resetComment(): void;
    get commentInput(): string | undefined;
    get createdAt(): number;
    get createdBy(): string;
    get effectiveOwner(): string;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _owner?;
    get owner(): string;
    set owner(value: string);
    resetOwner(): void;
    get ownerInput(): string | undefined;
    private _storageLocation?;
    get storageLocation(): string;
    set storageLocation(value: string);
    resetStorageLocation(): void;
    get storageLocationInput(): string | undefined;
    private _storageRoot?;
    get storageRoot(): string;
    set storageRoot(value: string);
    resetStorageRoot(): void;
    get storageRootInput(): string | undefined;
    get updatedAt(): number;
    get updatedBy(): string;
    private _object;
    get object(): SharePluginframeworkObjectList;
    putObject(value: SharePluginframeworkObject[] | cdktf.IResolvable): void;
    resetObject(): void;
    get objectInput(): cdktf.IResolvable | SharePluginframeworkObject[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
